﻿Type=Activity
Version=1.60
FullScreen=True
IncludeTitle=True
@EndOfDesignText@

Sub Process_Globals

End Sub

Sub Globals
	' Données utilisateur
	Dim dateNaissance, sexe As String
	Dim taille, activite, points As Int
	Dim DateDepart, derniereDate As String
	Dim PoidsDepart As Double
		
	' nécessaire pour dessiner la courbe
	Dim facteurX, facteurY As Double
	Dim tableau As Canvas
	Dim courbe As Path
	Dim curseur As Cursor
	
	'objects graphiques
	Dim bpValider As Button
	Dim edTxtPoids As EditText
	Dim lblPoids As Label
	Dim ZoneDessin As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("formHistory")
	Activity.Title = "FlexiPoint - "& Main.Utilisateur & " - " & Main.dateDuJour
	bpValider.Enabled = True
	edTxtPoids.Enabled = True

	'S'il n'y a pas de données utilisateur, il ne peut y avoir d'historique
	'On teste donc si les données existent
	'----------------------------------------------------------------------
	If File.Exists(File.DirDefaultExternal, "Utilisateur") = False Then 
		Msgbox("Problème de branchement programme", "Erreur fatale")
		Activity.Finish
	End If

	' Récupération des données utilisateur et vérification si date déjà saisie
	'--------------------------------------------------------------------------
	curseur = Main.SQL1.ExecQuery("SELECT Date, Poids FROM Agenda WHERE Poids IS NOT NULL")
	curseur.Position = 0
	DateDepart = curseur.GetString("Date")
	PoidsDepart = curseur.GetDouble("Poids")
	If curseur.RowCount > 1 Then
		curseur.Position = curseur.RowCount-1
		derniereDate = curseur.GetString("Date")
	Else
		derniereDate = 0
	End If
	For n=0 To curseur.RowCount-1
		If Main.dateDuJour = curseur.GetString("Date") Then
			bpValider.Enabled = False
			edTxtPoids.Enabled = False
		End If
	Next
	
	' Création du dessin
	'-------------------
	dessin(curseur)
	curseur.Close
	
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub dessin(curs As Cursor)
' échelle de temps: 1 px = 1 jour,
' au niveau du poids, échelle variable
' Taille du graphique: 480 x 500

	' Facteurs de correction d'échelle (X = Dates, Y = Poids)
	'---------------------------------------------------------
	If derniereDate <> 0 Then
		facteurX = (480 / (DateTime.DateParse(Main.dateDuJour) - DateTime.DateParse(DateDepart)))
	End If
	
	facteurY = (500 / ((PoidsDepart + 10) - (Main.Objectif - 10)))
	
	' Création de la zone de dessin
	'-------------------------------
	zonedessin.Width = 480
	tableau.Initialize(ZoneDessin)
	' dessine le cadre
	Dim rectangle As Rect
	rectangle.Initialize(0, 0, 479, 499)
	tableau.DrawRect(rectangle, Colors.DarkGray, False, 1)
	'dessine les lignes verticales des mois
	If derniereDate <> 0 Then
		For n=0 To 480	Step 69
			tableau.DrawLine(n, 0, n, 500, Colors.DarkGray,1)
		Next
	End If
	'création des droites horizontale tous les 5 kilos (avec label)
		For n=0 To 200 Step 5
		tempsY = Y(n)
		tableau.DrawLine(0, tempsY , 480, tempsY, Colors.DarkGray, 1)
		tableau.DrawText(n, 210, tempsY-1, Typeface.DEFAULT, 10, Colors.DarkGray, "LEFT")
	Next
	'création des droites horizontales correspondantes au poids de départ et à l'objectif
	tempsY = Y(PoidsDepart)
	tableau.DrawLine( 0, tempsY, 480, tempsY, Colors.Red, 1)
	tempsY = Y(Main.Objectif)
	tableau.DrawLine( 0, tempsY, 480, tempsY, Colors.Blue, 1)

	' création de la courbe
	'-----------------------
	courbe.Initialize(0, Y(PoidsDepart))
	For n = 0 To curs.RowCount - 1
		curs.Position = n
		posX = X(DateTime.DateParse(curs.GetString("Date")))
		posY = Y(curs.GetLong("Poids"))
		courbe.LineTo(posX, posY)
	Next
	tableau.DrawPath(courbe, Colors.Yellow, False, 2 )
End Sub

Sub bpValider_Click
	' Vérification si tous les champs sont saisis
	'---------------------------------------------
	If edTxtPoids.Text = "" Then 
		Msgbox("Remplir tous les champs", "Erreur")
		Return
	End If

	'Enregistrement
	'--------------
	Main.SQL1.ExecNonQuery("INSERT INTO Agenda VALUES (NULL, '" & Main.dateDuJour & "',NULL, NULL, NULL, NULL, NULL, "& edTxtPoids.Text &", NULL)")
	bpValider.Enabled = False
	edTxtPoids.Enabled = False
	
	'Modification du graphique
	'--------------------------
	curseur = Main.SQL1.ExecQuery("SELECT Date, Poids FROM Agenda WHERE Poids IS NOT NULL")
	dessin(curseur)
	curseur.Close
End Sub

Sub X(valeur As Double) As Int
	Return (Round (facteurX * (valeur - DateTime.DateParse(DateDepart))))
End Sub

Sub Y(valeur As Double) As Int
	Return (Round (500 - (facteurY * (valeur - (Main.Objectif - 10)))))
End Sub
